﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Net;
using System.Text;
using System.IO;

namespace DiscordAPI.Controllers
{
    public class DiscordAPIController : Controller
    {
        string client_id = "ADD Yours";
        string client_sceret = "ADD Yours";
        string redirect_url = "ADD Yours";

        public ActionResult Index()
        {
            if (Request.QueryString["code"] != null)
                ViewBag.user = CallAPI();
            return View();
        }

        [HttpPost]
        [ActionName("Index")]
        public ActionResult Index_Post()
        {
            /*Get Authorization code*/
            Response.Redirect("https://discordapp.com/api/oauth2/authorize?response_type=code&client_id=" + client_id + "&scope=identify%20guilds.join&state=15773059ghq9183habn&redirect_uri=" + redirect_url + "");

            return View();
        }

        public string CallAPI()
        {
            string code = Request.QueryString["code"];

            /*Get Access Token from authorization code by making http post request*/
            HttpWebRequest webRequest = (HttpWebRequest)WebRequest.Create("https://discordapp.com/api/oauth2/token");
            webRequest.Method = "POST";
            string parameters = "client_id=" + client_id + "&client_secret=" + client_sceret + "&grant_type=authorization_code&code=" + code + "&redirect_uri=" + redirect_url + "";
            byte[] byteArray = Encoding.UTF8.GetBytes(parameters);
            webRequest.ContentType = "application/x-www-form-urlencoded";
            webRequest.ContentLength = byteArray.Length;
            Stream postStream = webRequest.GetRequestStream();

            postStream.Write(byteArray, 0, byteArray.Length);
            postStream.Close();
            WebResponse response = webRequest.GetResponse();
            postStream = response.GetResponseStream();
            StreamReader reader = new StreamReader(postStream);
            string responseFromServer = reader.ReadToEnd();

            string tokenInfo = responseFromServer.Split(',')[0].Split(':')[1];
            string access_token = tokenInfo.Trim().Substring(1, tokenInfo.Length - 3);
            /*End*/

            /*Do http get request to the url to get the cleint info in json*/
            HttpWebRequest webRequest1 = (HttpWebRequest)WebRequest.Create("https://discordapp.com/api/users/@me");
            webRequest1.Method = "Get";
            webRequest1.ContentLength = 0;
            webRequest1.Headers.Add("Authorization", "Bearer " + access_token);
            webRequest1.ContentType = "application/x-www-form-urlencoded";

            string apiResponse1 = "";
            using (HttpWebResponse response1 = webRequest1.GetResponse() as HttpWebResponse)
            {
                StreamReader reader1 = new StreamReader(response1.GetResponseStream());
                apiResponse1 = reader1.ReadToEnd();
            }
            /*End*/

            string info1 = apiResponse1.Substring(1, apiResponse1.Length - 2).Replace(",", "<br/>");
            return info1;
        }
    }
}